org.apache.lucene.store.instantiated

## Class InstantiatedIndexReader

- java.lang.Object
- - org.apache.lucene.index.IndexReader
  - - org.apache.lucene.store.instantiated.InstantiatedIndexReader

- All Implemented Interfaces:
    java.lang.Cloneable

      public class InstantiatedIndexReader
      extends IndexReader

  An InstantiatedIndexReader is not a snapshot in time, it is completely in sync with the latest commit to the store!

  Consider using InstantiatedIndex as if it was immutable.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.IndexReader

      `IndexReader.FieldOption`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.index.IndexReader

      `hasChanges`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `InstantiatedIndexReader(InstantiatedIndex index)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Directory` | `directory()` Returns the directory associated with this index.
    `int` | `docFreq(Term t)` Returns the number of documents containing the term `t`.
    `protected void` | `doClose()` Implements close.
    `protected void` | `doCommit()` Implements commit.
    `Document` | `document(int n)` Returns the stored fields of the `n`th `Document` in this index.
    `Document` | `document(int n, FieldSelector fieldSelector)` Return the `Document` at the `n`th position.
    `protected void` | `doDelete(int docNum)` Implements deletion of the document numbered `docNum`.
    `protected void` | `doSetNorm(int doc, java.lang.String field, byte value)` Implements setNorm in subclass.
    `protected void` | `doUndeleteAll()` Implements actual undeleteAll() in subclass.
    `java.util.Collection` | `getFieldNames(IndexReader.FieldOption fieldOption)` Get a list of unique field names that exist in this index and have the specified field option information.
    `InstantiatedIndex` | `getIndex()`
    `TermFreqVector` | `getTermFreqVector(int docNumber, java.lang.String field)` Return a term frequency vector for the specified document and field.
    `void` | `getTermFreqVector(int docNumber, java.lang.String field, TermVectorMapper mapper)` Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
    `void` | `getTermFreqVector(int docNumber, TermVectorMapper mapper)` Map all the term vectors for all fields in a Document
    `TermFreqVector[]` | `getTermFreqVectors(int docNumber)` Return an array of term frequency vectors for the specified document.
    `long` | `getVersion()` An InstantiatedIndexReader is not a snapshot in time, it is completely in sync with the latest commit to the store!
    `boolean` | `hasDeletions()` Returns true if any documents have been deleted
    `boolean` | `isCurrent()` An InstantiatedIndexReader is always current! Check whether this IndexReader is still using the current (i.e., most recently committed) version of the index.
    `boolean` | `isDeleted(int n)` Returns true if document n has been deleted
    `boolean` | `isOptimized()` Checks is the index is optimized (if it has a single segment and no deletions).
    `int` | `maxDoc()` Returns one greater than the largest possible document number.
    `byte[]` | `norms(java.lang.String field)` never ever touch these values.
    `void` | `norms(java.lang.String field, byte[] bytes, int offset)` Reads the byte-encoded normalization factor for the named field of every document.
    `int` | `numDocs()` Returns the number of documents in this index.
    `TermDocs` | `termDocs()` Returns an unpositioned `TermDocs` enumerator.
    `TermDocs` | `termDocs(Term term)` Returns an enumeration of all the documents which contain `term`.
    `TermPositions` | `termPositions()` Returns an unpositioned `TermPositions` enumerator.
    `TermEnum` | `terms()` Returns an enumeration of all the terms in the index.
    `TermEnum` | `terms(Term t)` Returns an enumeration of all terms starting at a given term.

    - ### Methods inherited from class org.apache.lucene.index.IndexReader

      `acquireWriteLock, clone, clone, close, commit, commit, decRef, deleteDocument, deleteDocuments, ensureOpen, flush, flush, getCommitUserData, getCommitUserData, getCurrentVersion, getCurrentVersion, getCurrentVersion, getDeletesCacheKey, getDisableFakeNorms, getFieldCacheKey, getIndexCommit, getRefCount, getSequentialSubReaders, getTermInfosIndexDivisor, getUniqueTermCount, hasNorms, incRef, indexExists, indexExists, indexExists, isLocked, isLocked, lastModified, lastModified, lastModified, listCommits, main, numDeletedDocs, open, open, open, open, open, open, open, open, open, open, open, open, open, open, reopen, reopen, reopen, setDisableFakeNorms, setNorm, setNorm, setTermInfosIndexDivisor, termPositions, undeleteAll, unlock`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### InstantiatedIndexReader

          public InstantiatedIndexReader(InstantiatedIndex index)

  - ### Method Detail

    - #### isOptimized

          public boolean isOptimized()

      Description copied from class: `IndexReader`
      Checks is the index is optimized (if it has a single segment and no deletions). Not implemented in the IndexReader base class.
      Overrides:
        `isOptimized` in class `IndexReader`
      Returns:
        always true.

    - #### getVersion

          public long getVersion()

      An InstantiatedIndexReader is not a snapshot in time, it is completely in sync with the latest commit to the store!
      Overrides:
        `getVersion` in class `IndexReader`
      Returns:
        output from `InstantiatedIndex.getVersion()` in associated instantiated index.

    - #### directory

          public Directory directory()

      Description copied from class: `IndexReader`
      Returns the directory associated with this index. The Default implementation returns the directory specified by subclasses when delegating to the IndexReader(Directory) constructor, or throws an UnsupportedOperationException if one was not specified.
      Overrides:
        `directory` in class `IndexReader`

    - #### isCurrent

          public boolean isCurrent()
                            throws java.io.IOException

      An InstantiatedIndexReader is always current! Check whether this IndexReader is still using the current (i.e., most recently committed) version of the index. If a writer has committed any changes to the index since this reader was opened, this will return `false`, in which case you must open a new IndexReader in order to see the changes. See the description of the `autoCommit` flag which controls when the `IndexWriter` actually commits changes to the index.
      Overrides:
        `isCurrent` in class `IndexReader`
      Returns:
        always true
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error
        `java.lang.UnsupportedOperationException` - unless overridden in subclass

    - #### getIndex

          public InstantiatedIndex getIndex()

    - #### numDocs

          public int numDocs()

      Description copied from class: `IndexReader`
      Returns the number of documents in this index.
      Specified by:
        `numDocs` in class `IndexReader`

    - #### maxDoc

          public int maxDoc()

      Description copied from class: `IndexReader`
      Returns one greater than the largest possible document number. This may be used to, e.g., determine how big to allocate an array which will have an element for every document number in an index.
      Specified by:
        `maxDoc` in class `IndexReader`

    - #### hasDeletions

          public boolean hasDeletions()

      Description copied from class: `IndexReader`
      Returns true if any documents have been deleted
      Specified by:
        `hasDeletions` in class `IndexReader`

    - #### isDeleted

          public boolean isDeleted(int n)

      Description copied from class: `IndexReader`
      Returns true if document n has been deleted
      Specified by:
        `isDeleted` in class `IndexReader`

    - #### doDelete

          protected void doDelete(int docNum)
                           throws java.io.IOException

      Description copied from class: `IndexReader`
      Implements deletion of the document numbered `docNum`. Applications should call `IndexReader.deleteDocument(int)` or `IndexReader.deleteDocuments(Term)`.
      Specified by:
        `doDelete` in class `IndexReader`
      Throws:
        `java.io.IOException`

    - #### doUndeleteAll

          protected void doUndeleteAll()
                                throws java.io.IOException

      Description copied from class: `IndexReader`
      Implements actual undeleteAll() in subclass.
      Specified by:
        `doUndeleteAll` in class `IndexReader`
      Throws:
        `java.io.IOException`

    - #### doCommit

          protected void doCommit()
                           throws java.io.IOException

      Description copied from class: `IndexReader`
      Implements commit.
      Specified by:
        `doCommit` in class `IndexReader`
      Throws:
        `java.io.IOException`

    - #### doClose

          protected void doClose()
                          throws java.io.IOException

      Description copied from class: `IndexReader`
      Implements close.
      Specified by:
        `doClose` in class `IndexReader`
      Throws:
        `java.io.IOException`

    - #### getFieldNames

          public java.util.Collection getFieldNames(IndexReader.FieldOption fieldOption)

      Description copied from class: `IndexReader`
      Get a list of unique field names that exist in this index and have the specified field option information.
      Specified by:
        `getFieldNames` in class `IndexReader`
      Parameters:
        `fieldOption` - specifies which field option should be available for the returned fields
      Returns:
        Collection of Strings indicating the names of the fields.
      See Also:
        `IndexReader.FieldOption`

    - #### document

          public Document document(int n,
                                   FieldSelector fieldSelector)
                            throws CorruptIndexException,
                                   java.io.IOException

      Return the `Document` at the `n`th position.

      Warning! The resulting document is the actual stored document instance and not a deserialized clone as retuned by an IndexReader over a `Directory`. I.e., if you need to touch the document, clone it first!

      This can also be seen as a feature for live changes of stored values, but be careful! Adding a field with an name unknown to the index or to a field with previously no stored values will make `getFieldNames(org.apache.lucene.index.IndexReader.FieldOption)` out of sync, causing problems for instance when merging the instantiated index to another index.

      This implementation ignores the field selector! All stored fields are always returned!

      Specified by:
        `document` in class `IndexReader`
      Parameters:
        `n` - document number
        `fieldSelector` - ignored
      Returns:
        The stored fields of the `Document` at the nth position
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error
      See Also:
        `Fieldable`, `FieldSelector`, `SetBasedFieldSelector`, `LoadFirstFieldSelector`

    - #### document

          public Document document(int n)
                            throws java.io.IOException

      Returns the stored fields of the `n`th `Document` in this index.

      Warning! The resulting document is the actual stored document instance and not a deserialized clone as retuned by an IndexReader over a `Directory`. I.e., if you need to touch the document, clone it first!

      This can also be seen as a feature for live changes of stored values, but be careful! Adding a field with an name unknown to the index or to a field with previously no stored values will make `getFieldNames(org.apache.lucene.index.IndexReader.FieldOption)` out of sync, causing problems for instance when merging the instantiated index to another index.

      Overrides:
        `document` in class `IndexReader`
      Throws:
        `CorruptIndexException` - if the index is corrupt
        `java.io.IOException` - if there is a low-level IO error

    - #### norms

          public byte[] norms(java.lang.String field)
                       throws java.io.IOException

      never ever touch these values. it is the true values, unless norms have been touched.
      Specified by:
        `norms` in class `IndexReader`
      Throws:
        `java.io.IOException`
      See Also:
        `AbstractField.setBoost(float)`

    - #### norms

          public void norms(java.lang.String field,
                            byte[] bytes,
                            int offset)
                     throws java.io.IOException

      Description copied from class: `IndexReader`
      Reads the byte-encoded normalization factor for the named field of every document. This is used by the search code to score documents.
      Specified by:
        `norms` in class `IndexReader`
      Throws:
        `java.io.IOException`
      See Also:
        `AbstractField.setBoost(float)`

    - #### doSetNorm

          protected void doSetNorm(int doc,
                                   java.lang.String field,
                                   byte value)
                            throws java.io.IOException

      Description copied from class: `IndexReader`
      Implements setNorm in subclass.
      Specified by:
        `doSetNorm` in class `IndexReader`
      Throws:
        `java.io.IOException`

    - #### docFreq

          public int docFreq(Term t)
                      throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns the number of documents containing the term `t`.
      Specified by:
        `docFreq` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### terms

          public TermEnum terms()
                         throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an enumeration of all the terms in the index. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration. Note that after calling terms(), `TermEnum.next()` must be called on the resulting enumeration before calling other methods such as `TermEnum.term()`.
      Specified by:
        `terms` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### terms

          public TermEnum terms(Term t)
                         throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an enumeration of all terms starting at a given term. If the given term does not exist, the enumeration is positioned at the first term greater than the supplied term. The enumeration is ordered by Term.compareTo(). Each term is greater than all that precede it in the enumeration.
      Specified by:
        `terms` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### termDocs

          public TermDocs termDocs()
                            throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an unpositioned `TermDocs` enumerator.
      Specified by:
        `termDocs` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### termDocs

          public TermDocs termDocs(Term term)
                            throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an enumeration of all the documents which contain `term`. For each document, the document number, the frequency of the term in that document is also provided, for use in search scoring. If term is null, then all non-deleted docs are returned with freq=1. Thus, this method implements the mapping:

      Term => <docNum, freq>*

      The enumeration is ordered by document number. Each document number is greater than all that precede it in the enumeration.

      Overrides:
        `termDocs` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### termPositions

          public TermPositions termPositions()
                                      throws java.io.IOException

      Description copied from class: `IndexReader`
      Returns an unpositioned `TermPositions` enumerator.
      Specified by:
        `termPositions` in class `IndexReader`
      Throws:
        `java.io.IOException` - if there is a low-level IO error

    - #### getTermFreqVectors

          public TermFreqVector[] getTermFreqVectors(int docNumber)
                                              throws java.io.IOException

      Description copied from class: `IndexReader`
      Return an array of term frequency vectors for the specified document. The array contains a vector for each vectorized field in the document. Each vector contains terms and frequencies for all terms in a given vectorized field. If no such fields existed, the method returns null. The term vectors that are returned may either be of type `TermFreqVector` or of type `TermPositionVector` if positions or offsets have been stored.
      Specified by:
        `getTermFreqVectors` in class `IndexReader`
      Parameters:
        `docNumber` - document for which term frequency vectors are returned
      Returns:
        array of term frequency vectors. May be null if no term vectors have been stored for the specified document.
      Throws:
        `java.io.IOException` - if index cannot be accessed
      See Also:
        `Field.TermVector`

    - #### getTermFreqVector

          public TermFreqVector getTermFreqVector(int docNumber,
                                                  java.lang.String field)
                                           throws java.io.IOException

      Description copied from class: `IndexReader`
      Return a term frequency vector for the specified document and field. The returned vector contains terms and frequencies for the terms in the specified field of this document, if the field had the storeTermVector flag set. If termvectors had been stored with positions or offsets, a `TermPositionVector` is returned.
      Specified by:
        `getTermFreqVector` in class `IndexReader`
      Parameters:
        `docNumber` - document for which the term frequency vector is returned
        `field` - field for which the term frequency vector is returned.
      Returns:
        term frequency vector May be null if field does not exist in the specified document or term vector was not stored.
      Throws:
        `java.io.IOException` - if index cannot be accessed
      See Also:
        `Field.TermVector`

    - #### getTermFreqVector

          public void getTermFreqVector(int docNumber,
                                        java.lang.String field,
                                        TermVectorMapper mapper)
                                 throws java.io.IOException

      Description copied from class: `IndexReader`
      Load the Term Vector into a user-defined data structure instead of relying on the parallel arrays of the `TermFreqVector`.
      Specified by:
        `getTermFreqVector` in class `IndexReader`
      Parameters:
        `docNumber` - The number of the document to load the vector for
        `field` - The name of the field to load
        `mapper` - The `TermVectorMapper` to process the vector. Must not be null
      Throws:
        `java.io.IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

    - #### getTermFreqVector

          public void getTermFreqVector(int docNumber,
                                        TermVectorMapper mapper)
                                 throws java.io.IOException

      Description copied from class: `IndexReader`
      Map all the term vectors for all fields in a Document
      Specified by:
        `getTermFreqVector` in class `IndexReader`
      Parameters:
        `docNumber` - The number of the document to load the vector for
        `mapper` - The `TermVectorMapper` to process the vector. Must not be null
      Throws:
        `java.io.IOException` - if term vectors cannot be accessed or if they do not exist on the field and doc. specified.

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.